//rotor layout: PORTB 01346527 PORTA 01234567 PORTC 7654
#define F_CPU 16000000UL
#define offset1 15
#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdio.h>
#include <util/delay.h>
#include "IR_Receive.h"

unsigned int DISP_LINE = 0;

unsigned int time1 =0 ;
unsigned int time2 =0 ;
   		 int time3 =0 ;
         int n= 176;
         int mo=0;
		 

		

					
//				case 1: PORTB = 0x20; break;
//				case 2: PORTB = 0x80; break;
//				case 3: PORTA = 0x01; break;	
//				case 4: PORTA = 0x04; break;
//				case 5: PORTA = 0x10; break;
//				case 6: PORTA = 0x50; break;
//				case 7: PORTA = 0x10; PORTC = 0x80; break;
//				case 8: PORTA = 0x50; break;
//				case 9: PORTA = 0x10; break;
//				case 10: PORTA = 0x04; break;
//				case 11: PORTA = 0x01; break;
//				case 12: PORTB = 0x80; break;
//				case 13: PORTB = 0x20; break;
				
				
	
struct Letter_row    
{
    int A;     
    int B;    
    int C;       
};

struct Letter_row Letter_A[13]={{.A = 0, .B = 0x20,.C =0},{.A = 0, .B = 0x80,.C =0},
	{.A = 0x01, .B = 0,.C =0},{.A = 0x04, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0},{.A = 0x50, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0x80},
	{.A = 0x50, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0},{.A = 0x04, .B = 0,.C =0},{.A = 0x01, .B = 0,.C =0},{.A = 0, .B = 0x80,.C =0},{.A = 0, .B = 0x20,.C =0}
	};
	
struct Letter_row Letter_B[13]={{.A = 0, .B = 0x20,.C =0},{.A = 0, .B = 0x8,.C =0},
	{.A = 0x01, .B = 0,.C =0},{.A = 0x04, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0},{.A = 0x50, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0x80},
	{.A = 0x50, .B = 0,.C =0},{.A = 0x10, .B = 0,.C =0},{.A = 0x04, .B = 0,.C =0},{.A = 0x01, .B = 0,.C =0},{.A = 0, .B = 0x80,.C =0},{.A = 0, .B = 0x20,.C =0}
	};


struct Letter_row Num_0[8]={{.A = 0xFC, .B = 0x00,.C =0xC0},{.A = 0x02, .B = 0x00,.C =0x20},
{.A = 0x02, .B = 0x00,.C =0x20},{.A = 0x02, .B = 0x00,.C =0x20},{.A = 0x02, .B = 0x00,.C =0x20},{.A = 0x02, .B = 0x00,.C =0x20},{.A = 0xFC, .B = 0x00,.C =0xC0},{.A = 0x00, .B = 0x00,.C =0x00}};

struct Letter_row Num_1[8]={{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00, .B = 0x00,.C =0x00},
{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00, .B = 0x00,.C =0x00 } };
	
struct Letter_row Num_2[8]={{.A = 0x7E,.B=0x00,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0xC2,.B=0x00,.C=0xE0},{.A = 0x00,.B=0x00,.C=0x00},{.A = 0x00,.B=0,.C=0x00}};
	
struct Letter_row Num_3[8]={{.A = 0x02,.B=0x00,.C=0x00},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x42,.B=0x00,.C=0x20},{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Num_4[8]={{.A = 0xC0,.B=0x00,.C=0xE0},{.A = 0x40,.B=0,.C=0x00},{.A = 0x40,.B=0,.C=0x00},{.A = 0x40,.B=0,.C=0x00},{.A = 0x40,.B=0,.C=0x00},
{.A = 0xFE,.B=0x00,.C=0xE0},{.A = 0x00, .B = 0x00,.C =0x00},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Num_5[8]={{.A = 0xC2,.B=0x00,.C=0xE0},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x7E,.B=0x00,.C=0x20},{.A = 0x00,.B=0x00,.C=0x00},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Num_6[8]={{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x7E,.B=0x00,.C=0x20},{.A = 0x00,.B=0x00,.C=0x00},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Num_7[8]={{.A =0x00,.B=0x00,.C=0x20},{.A =0x00,.B=0x00,.C=0x20},{.A =0x00,.B=0x00,.C=0x20},{.A =0x00,.B=0x00,.C=0x20},{.A = 0xFE, .B = 0x00,.C =0xE0},
{.A =0x00,.B=0x00,.C=0x00},{.A =0x00,.B=0x00,.C=0x00},{.A =0x00,.B=0x00,.C=0x00}};
	
struct Letter_row Num_8[8]={{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x42,.B=0x00,.C=0x20},{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Num_9[8]={{.A = 0xC2, .B = 0x00,.C =0xE0},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x42,.B=0x00,.C=0x20},{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x00,.B=0,.C=0x00}};

struct Letter_row Dot[2] = {{.A=0x10,.B=0x00,.C=0x80},{.A=0x10,.B=0x00,.C=0x80}};
	
struct Letter_row Letter_C[13]={{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x02, .B = 0x00,.C =0x20}, {.A = 0x02, .B = 0x00,.C =0x20}, {.A = 0x02, .B = 0x00,.C =0x20}, {.A = 0x02, .B = 0x00,.C =0x20}, {.A = 0x02, .B = 0x00,.C =0x20}, {.A = 0x02, .B = 0x00,.C =0x20},
	{.A = 0x00, .B = 0x00,.C =0x00}
};

struct Letter_row Letter_J[10]={ {.A =0x02,.B=0x00,.C=0x40},{.A=0x01,.B=0x00,.C=0x40},{.A=0x00,.B=0x80,.C=0x40},{.A=0x00,.B=0x80,.C=0x40},
{.B=0x00,.A=0xFF,.C=0xC0},{.A=0x00,.B=0x00,.C=0x40},{.A=0x00,.B=0x00,.C=0x40},{.A=0x00,.B=0x00,.C=0x40},{.A=0x00,.B=0x00,.C=0x40}};

struct Letter_row Letter_S[10]={ {.A =0xE2,.B=0x00,.C=0x00},{.A=0x11,.B=0x00,.C=0x80},{.A=0x08,.B=0x80,.C=0x40},{.A=0x08,.B=0x80,.C=0x40},{.A=0x08,.B=0x80,.C=0x40},{.A=0x04,.B=0x80,.C=0x80},
{.A=0x83,.B=0x00,.C=0x00}};




struct Letter_row Letter_E[8]={{.A = 0xFE, .B = 0x00,.C =0xE0},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},{.A = 0x42,.B=0,.C=0x20},
{.A = 0x42,.B=0,.C=0x20}, {.A = 0x0,.B=0,.C=0x0}};
	
struct Letter_row Letter_Y[10]={{.A=0x00,.B=0x00,.C=0x40},{.A=0x00,.B=0x00,.C=0x80},{.A=0x80,.B=0x00,.C=0x00},{.A=0x7F,.B=0x80,.C=0x00},
{.A=0x80,.B=0x00,.C=0x00},{.A=0x00,.B=0x00,.C=0x80},{.A=0x00,.B=0x00,.C=0x40}};



struct Letter_row Letter1[13]={};
struct Letter_row Letter2[13]={};
struct Letter_row Number_0[8]={};
struct Letter_row Number_1[8]={};
struct Letter_row Number_2[8]={};
struct Letter_row Number_3[8]={};
struct Letter_row Number_4[8]={};
struct Letter_row Number_5[8]={};



ISR (INT0_vect) {
    if(key_code!=0x0c)
	OCR3A =(TCNT1/180);
	else
	OCR3A = TCNT1/185;

	mo = TCNT1/OCR3A;
	TCNT1=0;
	TCNT3 = 0;
	DISP_LINE = 0;
	if(display_on){
		switch (key_code){
			case 0x0C:
				PORTC = 0x70;
				PORTA = 0xB8;
				if(second==0)
					   {PORTA |= 0xFF;
						PORTB |= 0xFF;}
				break;
			case 0x16:
				PORTB = 0x01;
				break;
			case 0x45:
				PORTA = 0;
				PORTB = 0;
				PORTC = 0;
				break;
			case 0x47:
				break;

		}
	}
}

ISR(TIMER0_COMPA_vect) {
	time1++;
	time2++;
	time3++;
	if(time3 == 500)
	{
	cursor_on = ~cursor_on;
	time3 = 0;
	}
	if(time2 == 100){
	 	n= (n-5)*sft_en;
		if(n<=0)
		n=mo;
	 	time2 = 0;
	}


	if(time1 == 1000) {
		
			second ++; time1 = 0;
			if(second == 60) {minute ++; second = 0;}
			
			if(minute == 60) {hour ++; minute = 0;}
			
			if(hour == 24) {hour =0;}
	}
	
}

ISR (TIMER3_COMPA_vect) {
	
	 DISP_LINE ++;
	 if(display_on) {
	 switch (key_code){
		case 0x18: break;
		case 0x5A:break;
		case 0x42:break;
		case 0x1C:break;
		case 0x0D:break;
		case 0x0C:{	
			   PORTC = 0x0;
			   PORTA = 0x0;
			   PORTB = 0x01;
			   switch (DISP_LINE)    
			   {
					
					case 180*1/12 :   PORTC = 0x30;  break;
					case 180*2/12 :    PORTC = 0x30; break;
					case 180*4/12 :    PORTC = 0x30; break;
					case 180*5/12 :    PORTC = 0x30; break;
					case 180*7/12 :    PORTC = 0x30; break;
					case 180*8/12 :    PORTC = 0x30; break;
					case 180*10/12 :   PORTC = 0x30; break;
					case 180*11/12 :   PORTC = 0x30;  break;
					case 180*3/12 :    PORTC = 0x70; PORTA = 0xF8; break;
					case 180*6/12 :    PORTC = 0x70; PORTA = 0x94; break;
					case 180*9/12 :    PORTC = 0x70; PORTA = 0x90;break;
					case 0:   PORTC = 0x70; break;
					
					//3
					case 43: PORTA = 0xA8;break;
					case 44:  PORTA =  0xA8;  break;
					
					//6
					case 88: PORTA = 0x64; break;
					case 89: PORTA = 0x94; break;
					case 91: PORTA = 0x78;break;
					
					//9
					case 133: PORTA = 0x60;break;
					case 134:PORTA = 0x90; break;
					case 136: PORTA = 0x7E;break;
					
					//12
					case 176: PORTA = 0xF8;break;
					case 1: PORTA = 0xA8;break;
					case 2: PORTA = 0xE8;break;
				
				}	
			 
				if(DISP_LINE == second * 3)
				{
						PORTA |= 0xFF;
						PORTB |= 0xFF;
				}
				else if(DISP_LINE == minute * 3)
				{
				PORTA |= 0x1F;
				PORTB |= 0xFF;
				}
					 


				break;
		}		
		case 0x16: {
			PORTA = 0;
			PORTC = 0;
			PORTB = 0; 
			
			switch (DISP_LINE){
				case 89: PORTC = 0x20; break;
				case 80:PORTA =  0x10;break;
				case 99: PORTA = 0x10;break;
				
				case 0: PORTB = 0x01;break;
				
				case 170: PORTA = 0x01;break;
				case  8: PORTA = 0x01;break;
				
				case 164: PORTC =  0x80;break;
				case 14: PORTC = 0x80;break;
				
				case 153: PORTA = 0x80; break;
				case  30: PORTA = 0x80;break;
				
				case 140: PORTA = 0x10;break;
				case 44: PORTA = 0x10;break;
				
				case 120: PORTA = 0x01; break;
				case  62: PORTA = 0x04; break;
				
			}
			break;
		}
		case 0x45: {
			PORTA = 0;
			PORTB = 0;
			PORTC = 0;
			
			
			switch (DISP_LINE) {
				case 85: PORTC = 0x80; PORTA =  0xF8;break;
				case 86: PORTC = 0x80; PORTA = 0x40;break;
				case 87: PORTC = 0x80; PORTA = 0x40;break;
				case 88: PORTA = 0x80; break;
				
				case 90: PORTA = 0x38; break;
				case 91: PORTA = 0x40; break;
				case 92: PORTA = 0x40; break;
				case 93:PORTA  = 0x20; break;
				
				case 95: PORTA = 0x30; break;
				case 96: PORTA = 0x68; break;
				case 97: PORTA = 0x68;break;
				case 98: PORTA = 0x20;break;
				
				case 100: PORTA = 0x68; break;
				case 101: PORTA = 0x68;break;
				case 102: PORTA = 0x58;break;
				
				case 104: PORTA = 0x68; break;
				case 105: PORTA = 0x68;break;
				case 106: PORTA = 0x58;break;
				
				default:
					break;
			}
			

			break; //power button
		}
		
		
		case 0x47: {
		
			
			switch ((DISP_LINE+n)%mo){
			
           case 1:  PORTA= Letter1[12].A; PORTB= Letter1[12].B; PORTC= Letter1[12].C;break;
           case 2:  PORTA= Letter1[11].A; PORTB= Letter1[11].B; PORTC= Letter1[11].C;break;	
           case 3:  PORTA= Letter1[10].A; PORTB= Letter1[10].B; PORTC= Letter1[10].C;break;
           case 4: PORTA= Letter1[9].A; PORTB= Letter1[9].B; PORTC= Letter1[9].C;break;	
           case 5: PORTA= Letter1[8].A; PORTB= Letter1[8].B; PORTC= Letter1[8].C;break;
           case 6: PORTA= Letter1[7].A; PORTB= Letter1[7].B; PORTC= Letter1[7].C;break;	
           case 7: PORTA= Letter1[6].A; PORTB= Letter1[6].B; PORTC= Letter1[6].C;break;
           case 8: PORTA= Letter1[5].A; PORTB= Letter1[5].B; PORTC= Letter1[5].C;break;	
           case 9: PORTA= Letter1[4].A; PORTB= Letter1[4].B; PORTC= Letter1[4].C;break;
           case 10: PORTA= Letter1[3].A; PORTB= Letter1[3].B; PORTC= Letter1[3].C;break;	
           case 11: PORTA= Letter1[2].A; PORTB= Letter1[2].B; PORTC= Letter1[2].C;break;
           case 12: PORTA= Letter1[1].A; PORTB= Letter1[1].B; PORTC= Letter1[1].C;break;	
           case 13: PORTA= Letter1[0].A; PORTB= Letter1[0].B; PORTC= Letter1[0].C;break;
       	  
        
          
  			 	default: PORTA = 0;
									PORTB = 0;
									PORTC = 0; break;      
          }
			
			break; //power button
		}
		
		case 0x5e: {
		
			
		  switch (DISP_LINE){
			
           case 1:  PORTA= Number_0[0].A; PORTB= Number_0[0].B; PORTC= Number_0[0].C;break;
           case 2:  PORTA= Number_0[1].A; PORTB= Number_0[1].B; PORTC= Number_0[1].C;break;	
           case 3:  PORTA= Number_0[2].A; PORTB= Number_0[2].B; PORTC= Number_0[2].C;break;
           case 4: PORTA= Number_0[3].A; PORTB= Number_0[3].B; PORTC= Number_0[3].C;break;	
           case 5: PORTA= Number_0[4].A; PORTB= Number_0[4].B; PORTC= Number_0[4].C;break;
           case 6: PORTA= Number_0[5].A; PORTB= Number_0[5].B; PORTC= Number_0[5].C;break;	
           case 7: PORTA= Number_0[6].A; PORTB= Number_0[6].B; PORTC= Number_0[6].C;break;
           case 8: PORTA= Number_0[7].A; PORTB= Number_0[7].B; PORTC= Number_0[7].C;break;	

		       case 10:  PORTA= Number_1[0].A; PORTB= Number_1[0].B; PORTC= Number_1[0].C;break;
           case 11:  PORTA= Number_1[1].A; PORTB= Number_1[1].B; PORTC= Number_1[1].C;break;	
           case 12:  PORTA= Number_1[2].A; PORTB= Number_1[2].B; PORTC= Number_1[2].C;break;
           case 13: PORTA= Number_1[3].A; PORTB= Number_1[3].B; PORTC= Number_1[3].C;break;	
           case 14: PORTA= Number_1[4].A; PORTB= Number_1[4].B; PORTC= Number_1[4].C;break;
           case 15: PORTA= Number_1[5].A; PORTB= Number_1[5].B; PORTC= Number_1[5].C;break;	
           case 16: PORTA= Number_1[6].A; PORTB= Number_1[6].B; PORTC= Number_1[6].C;break;
           case 17: PORTA= Number_1[7].A; PORTB= Number_1[7].B; PORTC= Number_1[7].C;break;	
           
		   case 19: PORTA= Dot[0].A; PORTB=Dot[0].B; PORTC =Dot[0].C; break;
		   case 20: PORTA= Dot[1].A; PORTB=Dot[1].B; PORTC =Dot[1].C; break;         
		   
		   
		       case 23:  PORTA= Number_2[0].A; PORTB= Number_2[0].B; PORTC= Number_2[0].C;break;
           case 24:  PORTA= Number_2[1].A; PORTB= Number_2[1].B; PORTC= Number_2[1].C;break;	
           case 25:  PORTA= Number_2[2].A; PORTB= Number_2[2].B; PORTC= Number_2[2].C;break;
           case 26: PORTA= Number_2[3].A; PORTB= Number_2[3].B; PORTC= Number_2[3].C;break;	
           case 27: PORTA= Number_2[4].A; PORTB= Number_2[4].B; PORTC= Number_2[4].C;break;
           case 28: PORTA= Number_2[5].A; PORTB= Number_2[5].B; PORTC= Number_2[5].C;break;	
           case 29: PORTA= Number_2[6].A; PORTB= Number_2[6].B; PORTC= Number_2[6].C;break;
           case 30: PORTA= Number_2[7].A; PORTB= Number_2[7].B; PORTC= Number_2[7].C;break;	   
           	
       		 case 32:  PORTA= Number_3[0].A; PORTB= Number_3[0].B; PORTC= Number_3[0].C;break;
           case 33:  PORTA= Number_3[1].A; PORTB= Number_3[1].B; PORTC= Number_3[1].C;break;	
           case 34:  PORTA= Number_3[2].A; PORTB= Number_3[2].B; PORTC= Number_3[2].C;break;
           case 35: PORTA= Number_3[3].A; PORTB= Number_3[3].B; PORTC= Number_3[3].C;break;	
           case 36: PORTA= Number_3[4].A; PORTB= Number_3[4].B; PORTC= Number_3[4].C;break;
           case 37: PORTA= Number_3[5].A; PORTB= Number_3[5].B; PORTC= Number_3[5].C;break;	
           case 38: PORTA= Number_3[6].A; PORTB= Number_3[6].B; PORTC= Number_3[6].C;break;
           case 39: PORTA= Number_3[7].A; PORTB= Number_3[7].B; PORTC= Number_3[7].C;break;	  
           	
           case 41: PORTA= Dot[0].A; PORTB=Dot[0].B; PORTC =Dot[0].C; break;
		       case 42: PORTA= Dot[1].A; PORTB=Dot[0].B; PORTC =Dot[1].C; break;         
		   
		   
		       case 45:  PORTA= Number_4[0].A; PORTB= Number_4[0].B; PORTC= Number_4[0].C;break;
           case 46:  PORTA= Number_4[1].A; PORTB= Number_4[1].B; PORTC= Number_4[1].C;break;	
           case 47:  PORTA= Number_4[2].A; PORTB= Number_4[2].B; PORTC= Number_4[2].C;break;
           case 48: PORTA= Number_4[3].A; PORTB= Number_4[3].B; PORTC= Number_4[3].C;break;	
           case 49: PORTA= Number_4[4].A; PORTB= Number_4[4].B; PORTC= Number_4[4].C;break;
           case 50: PORTA= Number_4[5].A; PORTB= Number_4[5].B; PORTC= Number_4[5].C;break;	
           case 51: PORTA= Number_4[6].A; PORTB= Number_4[6].B; PORTC= Number_4[6].C;break;
           case 52: PORTA= Number_4[7].A; PORTB= Number_4[7].B; PORTC= Number_4[7].C;break;	   
           	
       		 case 54: PORTA= Number_5[0].A; PORTB= Number_5[0].B; PORTC= Number_5[0].C;break;
           case 55: PORTA= Number_5[1].A; PORTB= Number_5[1].B; PORTC= Number_5[1].C;break;	
           case 56: PORTA= Number_5[2].A; PORTB= Number_5[2].B; PORTC= Number_5[2].C;break;
           case 57: PORTA= Number_5[3].A; PORTB= Number_5[3].B; PORTC= Number_5[3].C;break;	
           case 58: PORTA= Number_5[4].A; PORTB= Number_5[4].B; PORTC= Number_5[4].C;break;
           case 59: PORTA= Number_5[5].A; PORTB= Number_5[5].B; PORTC= Number_5[5].C;break;	
           case 60: PORTA= Number_5[6].A; PORTB= Number_5[6].B; PORTC= Number_5[6].C;break;
           case 61: PORTA= Number_5[7].A; PORTB= Number_5[7].B; PORTC= Number_5[7].C;break;	  	



  		   default: PORTA = 0;
					PORTB = 0;
					PORTC = 0; break;      
          }
			
			break; //power button
		}
		
		
		case 0x44: {
			

			
		  switch (DISP_LINE){
			
           case 1:  PORTA= Number_0[0].A; PORTB= Number_0[0].B; PORTC= Number_0[0].C;break;
           case 2:  PORTA= Number_0[1].A; PORTB= Number_0[1].B; PORTC= Number_0[1].C;break;	
           case 3:  PORTA= Number_0[2].A; PORTB= Number_0[2].B; PORTC= Number_0[2].C;break;
           case 4: PORTA= Number_0[3].A; PORTB= Number_0[3].B; PORTC= Number_0[3].C;break;	
           case 5: PORTA= Number_0[4].A; PORTB= Number_0[4].B; PORTC= Number_0[4].C;break;
           case 6: PORTA= Number_0[5].A; PORTB= Number_0[5].B; PORTC= Number_0[5].C;break;	
           case 7: PORTA= Number_0[6].A; PORTB= Number_0[6].B; PORTC= Number_0[6].C;break;
           case 8: PORTA= Number_0[7].A; PORTB= Number_0[7].B; PORTC= Number_0[7].C;break;	

		       case 10:  PORTA= Number_1[0].A; PORTB= Number_1[0].B; PORTC= Number_1[0].C;break;
           case 11:  PORTA= Number_1[1].A; PORTB= Number_1[1].B; PORTC= Number_1[1].C;break;	
           case 12:  PORTA= Number_1[2].A; PORTB= Number_1[2].B; PORTC= Number_1[2].C;break;
           case 13: PORTA= Number_1[3].A; PORTB= Number_1[3].B; PORTC= Number_1[3].C;break;	
           case 14: PORTA= Number_1[4].A; PORTB= Number_1[4].B; PORTC= Number_1[4].C;break;
           case 15: PORTA= Number_1[5].A; PORTB= Number_1[5].B; PORTC= Number_1[5].C;break;	
           case 16: PORTA= Number_1[6].A; PORTB= Number_1[6].B; PORTC= Number_1[6].C;break;
           case 17: PORTA= Number_1[7].A; PORTB= Number_1[7].B; PORTC= Number_1[7].C;break;	
           
		   case 19: PORTA= Dot[0].A; PORTB=Dot[0].B; PORTC =Dot[0].C; break;
		   case 20: PORTA= Dot[1].A; PORTB=Dot[1].B; PORTC =Dot[1].C; break;         
		   
		   
		       case 23:  PORTA= Number_2[0].A; PORTB= Number_2[0].B; PORTC= Number_2[0].C;break;
           case 24:  PORTA= Number_2[1].A; PORTB= Number_2[1].B; PORTC= Number_2[1].C;break;	
           case 25:  PORTA= Number_2[2].A; PORTB= Number_2[2].B; PORTC= Number_2[2].C;break;
           case 26: PORTA= Number_2[3].A; PORTB= Number_2[3].B; PORTC= Number_2[3].C;break;	
           case 27: PORTA= Number_2[4].A; PORTB= Number_2[4].B; PORTC= Number_2[4].C;break;
           case 28: PORTA= Number_2[5].A; PORTB= Number_2[5].B; PORTC= Number_2[5].C;break;	
           case 29: PORTA= Number_2[6].A; PORTB= Number_2[6].B; PORTC= Number_2[6].C;break;
           case 30: PORTA= Number_2[7].A; PORTB= Number_2[7].B; PORTC= Number_2[7].C;break;	   
           	
       		 case 32:  PORTA= Number_3[0].A; PORTB= Number_3[0].B; PORTC= Number_3[0].C;break;
           case 33:  PORTA= Number_3[1].A; PORTB= Number_3[1].B; PORTC= Number_3[1].C;break;	
           case 34:  PORTA= Number_3[2].A; PORTB= Number_3[2].B; PORTC= Number_3[2].C;break;
           case 35: PORTA= Number_3[3].A; PORTB= Number_3[3].B; PORTC= Number_3[3].C;break;	
           case 36: PORTA= Number_3[4].A; PORTB= Number_3[4].B; PORTC= Number_3[4].C;break;
           case 37: PORTA= Number_3[5].A; PORTB= Number_3[5].B; PORTC= Number_3[5].C;break;	
           case 38: PORTA= Number_3[6].A; PORTB= Number_3[6].B; PORTC= Number_3[6].C;break;
           case 39: PORTA= Number_3[7].A; PORTB= Number_3[7].B; PORTC= Number_3[7].C;break;	  
           	
           case 41: PORTA= Dot[0].A; PORTB=Dot[0].B; PORTC =Dot[0].C; break;
		       case 42: PORTA= Dot[1].A; PORTB=Dot[0].B; PORTC =Dot[1].C; break;         
		   
		   
		       case 45:  PORTA= Number_4[0].A; PORTB= Number_4[0].B; PORTC= Number_4[0].C;break;
           case 46:  PORTA= Number_4[1].A; PORTB= Number_4[1].B; PORTC= Number_4[1].C;break;	
           case 47:  PORTA= Number_4[2].A; PORTB= Number_4[2].B; PORTC= Number_4[2].C;break;
           case 48: PORTA= Number_4[3].A; PORTB= Number_4[3].B; PORTC= Number_4[3].C;break;	
           case 49: PORTA= Number_4[4].A; PORTB= Number_4[4].B; PORTC= Number_4[4].C;break;
           case 50: PORTA= Number_4[5].A; PORTB= Number_4[5].B; PORTC= Number_4[5].C;break;	
           case 51: PORTA= Number_4[6].A; PORTB= Number_4[6].B; PORTC= Number_4[6].C;break;
           case 52: PORTA= Number_4[7].A; PORTB= Number_4[7].B; PORTC= Number_4[7].C;break;	   
           	
       		 case 54: PORTA= Number_5[0].A; PORTB= Number_5[0].B; PORTC= Number_5[0].C;break;
           case 55: PORTA= Number_5[1].A; PORTB= Number_5[1].B; PORTC= Number_5[1].C;break;	
           case 56: PORTA= Number_5[2].A; PORTB= Number_5[2].B; PORTC= Number_5[2].C;break;
           case 57: PORTA= Number_5[3].A; PORTB= Number_5[3].B; PORTC= Number_5[3].C;break;	
           case 58: PORTA= Number_5[4].A; PORTB= Number_5[4].B; PORTC= Number_5[4].C;break;
           case 59: PORTA= Number_5[5].A; PORTB= Number_5[5].B; PORTC= Number_5[5].C;break;	
           case 60: PORTA= Number_5[6].A; PORTB= Number_5[6].B; PORTC= Number_5[6].C;break;
           case 61: PORTA= Number_5[7].A; PORTB= Number_5[7].B; PORTC= Number_5[7].C;break;	  	

           

  		   default: PORTA = 0;
					PORTB = 0;
					PORTC = 0; break;      
          }
		   if((DISP_LINE >= cursor)&&(DISP_LINE <cursor+8)&&(cursor_on))
		      PORTA|= 0x01;			

			break; //pow
		}

		case 0x8: {
		 // if((DISP_LINE >= cursor)&&(DISP_LINE <cursor+8))
		 //  PORTA= cursor_on << PINA0;
			
		  switch ((DISP_LINE+n)%mo){
		  	
           case 1:PORTA=	Letter_E[0].A; PORTB=  Letter_E[0].B; PORTC =Letter_E[0].C; break;
           case 2:PORTA=	Letter_E[1].A; PORTB=  Letter_E[1].B; PORTC =Letter_E[1].C; break;
           case 3:PORTA=	Letter_E[2].A; PORTB=  Letter_E[2].B; PORTC =Letter_E[2].C; break;
           case 4:PORTA=	Letter_E[3].A; PORTB=  Letter_E[3].B; PORTC =Letter_E[3].C; break;
        	 case 5:PORTA=	Letter_E[4].A; PORTB=  Letter_E[4].B; PORTC =Letter_E[4].C; break;
        	 case 6:PORTA=	Letter_E[5].A; PORTB=  Letter_E[5].B; PORTC =Letter_E[5].C; break;
        	 case 7:PORTA=	Letter_E[6].A; PORTB=  Letter_E[6].B; PORTC =Letter_E[6].C; break;
        	 case 8:PORTA=	Letter_E[7].A; PORTB=  Letter_E[7].B; PORTC =Letter_E[7].C; break;
        	 	
        	 case 11:PORTA=	Letter_C[0].A; PORTB=  Letter_C[0].B; PORTC =Letter_C[0].C; break;
           case 12:PORTA=	Letter_C[1].A; PORTB=  Letter_C[1].B; PORTC =Letter_C[1].C; break;
           case 13:PORTA=	Letter_C[2].A; PORTB=  Letter_C[2].B; PORTC =Letter_C[2].C; break;
           case 14:PORTA=	Letter_C[3].A; PORTB=  Letter_C[3].B; PORTC =Letter_C[3].C; break;
        	 case 15:PORTA=	Letter_C[4].A; PORTB=  Letter_C[4].B; PORTC =Letter_C[4].C; break;
        	 case 16:PORTA=	Letter_C[5].A; PORTB=  Letter_C[5].B; PORTC =Letter_C[5].C; break;
        	 case 17:PORTA=	Letter_C[6].A; PORTB=  Letter_C[6].B; PORTC =Letter_C[6].C; break;
        	 case 18:PORTA=	Letter_C[7].A; PORTB=  Letter_C[7].B; PORTC =Letter_C[7].C; break;	
        	 
        	 case 20:PORTA=	Letter_E[0].A; PORTB=  Letter_E[0].B; PORTC = Letter_E[0].C; break;	
           case 21:PORTA=	Letter_E[1].A; PORTB=  Letter_E[1].B; PORTC = Letter_E[1].C; break;
           case 22:PORTA=	Letter_E[2].A; PORTB=  Letter_E[2].B; PORTC =Letter_E[2].C; break;
           case 23:PORTA=	Letter_E[3].A; PORTB=  Letter_E[3].B; PORTC =Letter_E[3].C; break;
        	 case 24:PORTA=	Letter_E[4].A; PORTB=  Letter_E[4].B; PORTC =Letter_E[4].C; break;
        	 case 25:PORTA=	Letter_E[5].A; PORTB=  Letter_E[5].B; PORTC =Letter_E[5].C; break;
        	 case 26:PORTA=	Letter_E[6].A; PORTB=  Letter_E[6].B; PORTC =Letter_E[6].C; break;
        	 case 27:PORTA=	Letter_E[7].A; PORTB=  Letter_E[7].B; PORTC =Letter_E[7].C; break;	
 
           case 40: PORTA  =Num_4[0].A; PORTB  =Num_4[0].B; PORTC  =Num_4[0].C; break;
           case 41: PORTA  =Num_4[1].A; PORTB  =Num_4[1].B; PORTC  =Num_4[1].C; break;
           case 42: PORTA  =Num_4[2].A; PORTB  =Num_4[2].B; PORTC  =Num_4[2].C; break;
           case 43: PORTA  =Num_4[3].A; PORTB  =Num_4[3].B; PORTC  =Num_4[3].C; break;
           case 44: PORTA  =Num_4[4].A; PORTB  =Num_4[4].B; PORTC  =Num_4[4].C; break;
           case 45: PORTA  =Num_4[5].A; PORTB  =Num_4[5].B; PORTC  =Num_4[5].C; break;
           case 46: PORTA  =Num_4[6].A; PORTB  =Num_4[6].B; PORTC  =Num_4[6].C; break;
           case 47: PORTA  =Num_4[7].A; PORTB  =Num_4[7].B; PORTC  =Num_4[7].C; break;		
           	
           case 49: PORTA  =Num_7[0].A; PORTB  =Num_7[0].B; PORTC  =Num_7[0].C; break;
           case 50: PORTA  =Num_7[1].A; PORTB  =Num_7[1].B; PORTC  =Num_7[1].C; break;
           case 51: PORTA  =Num_7[2].A; PORTB  =Num_7[2].B; PORTC  =Num_7[2].C; break;
           case 52: PORTA  =Num_7[3].A; PORTB  =Num_7[3].B; PORTC  =Num_7[3].C; break;
           case 53: PORTA  =Num_7[4].A; PORTB  =Num_7[4].B; PORTC  =Num_7[4].C; break;
           case 54: PORTA  =Num_7[5].A; PORTB  =Num_7[5].B; PORTC  =Num_7[5].C; break;
           case 55: PORTA  =Num_7[6].A; PORTB  =Num_7[6].B; PORTC  =Num_7[6].C; break;
           case 56: PORTA  =Num_7[7].A; PORTB  =Num_7[7].B; PORTC  =Num_7[7].C; break;				
           	
           case 58: PORTA  =Num_6[0].A; PORTB  =Num_6[0].B; PORTC  =Num_6[0].C; break;
           case 59: PORTA  =Num_6[1].A; PORTB  =Num_6[1].B; PORTC  =Num_6[1].C; break;
           case 60: PORTA  =Num_6[2].A; PORTB  =Num_6[2].B; PORTC  =Num_6[2].C; break;
           case 61: PORTA  =Num_6[3].A; PORTB  =Num_6[3].B; PORTC  =Num_6[3].C; break;
           case 62: PORTA  =Num_6[4].A; PORTB  =Num_6[4].B; PORTC  =Num_6[4].C; break;
           case 63: PORTA  =Num_6[5].A; PORTB  =Num_6[5].B; PORTC  =Num_6[5].C; break;
           case 64: PORTA  =Num_6[6].A; PORTB  =Num_6[6].B; PORTC  =Num_6[6].C; break;
           case 65: PORTA  =Num_6[7].A; PORTB  =Num_6[7].B; PORTC  =Num_6[7].C; break; 		
           	
           case 67: PORTA  =Num_0[0].A; PORTB  =Num_0[0].B; PORTC  =Num_0[0].C; break;
           case 68: PORTA  =Num_0[1].A; PORTB  =Num_0[1].B; PORTC  =Num_0[1].C; break;
           case 69: PORTA  =Num_0[2].A; PORTB  =Num_0[2].B; PORTC  =Num_0[2].C; break;
           case 70: PORTA  =Num_0[3].A; PORTB  =Num_0[3].B; PORTC  =Num_0[3].C; break;
           case 71: PORTA  =Num_0[4].A; PORTB  =Num_0[4].B; PORTC  =Num_0[4].C; break;
           case 72: PORTA  =Num_0[5].A; PORTB  =Num_0[5].B; PORTC  =Num_0[5].C; break;
           case 73: PORTA  =Num_0[6].A; PORTB  =Num_0[6].B; PORTC  =Num_0[6].C; break;
           case 74: PORTA  =Num_0[7].A; PORTB  =Num_0[7].B; PORTC  =Num_0[7].C; break; 			
 
          case 85:  PORTA =Letter_J[0].A;PORTB =Letter_J[0].B; PORTC =Letter_J[0].C; break;
		  case 86:  PORTA =Letter_J[1].A;PORTB =Letter_J[1].B; PORTC =Letter_J[1].C;  break;
		  case 87:  PORTA =Letter_J[2].A;PORTB =Letter_J[2].B; PORTC =Letter_J[2].C;  break;
		  case 88:  PORTA =Letter_J[3].A;PORTB =Letter_J[3].B; PORTC =Letter_J[3].C;  break;
		  case 89:  PORTA =Letter_J[4].A;PORTB =Letter_J[4].B; PORTC =Letter_J[4].C;  break;
		  case 90:  PORTA =Letter_J[5].A;PORTB =Letter_J[5].B; PORTC =Letter_J[5].C;  break;
		  case 91:  PORTA =Letter_J[6].A;PORTB =Letter_J[6].B; PORTC =Letter_J[6].C;  break;
		  case 92:  PORTA =Letter_J[7].A;PORTB =Letter_J[7].B; PORTC =Letter_J[7].C;  break;
		  case 93:  PORTA =Letter_J[8].A;PORTB =Letter_J[8].B; PORTC =Letter_J[8].C;  break;
		  case 94:  PORTA =Letter_J[9].A;PORTB =Letter_J[9].B; PORTC =Letter_J[9].C;  break;


		  case 98:  PORTA =Letter_S[0].A;PORTB =Letter_S[0].B; PORTC =Letter_S[0].C; break;
		  case 99:  PORTA =Letter_S[1].A;PORTB =Letter_S[1].B; PORTC =Letter_S[1].C;  break;
		  case 100:  PORTA =Letter_S[2].A;PORTB =Letter_S[2].B; PORTC =Letter_S[2].C;  break;
		  case 101:  PORTA =Letter_S[3].A;PORTB =Letter_S[3].B; PORTC =Letter_S[3].C;  break;
		  case 102:  PORTA =Letter_S[4].A;PORTB =Letter_S[4].B; PORTC =Letter_S[4].C;  break;
		  case 103:  PORTA =Letter_S[5].A;PORTB =Letter_S[5].B; PORTC =Letter_S[5].C;  break;
		  case 104:  PORTA =Letter_S[6].A;PORTB =Letter_S[6].B; PORTC =Letter_S[6].C;  break;
		  case 105:  PORTA =Letter_S[7].A;PORTB =Letter_S[7].B; PORTC =Letter_S[7].C;  break;
		  case 106:  PORTA =Letter_S[8].A;PORTB =Letter_S[8].B; PORTC =Letter_S[8].C;  break;
		  case 107:  PORTA =Letter_S[9].A;PORTB =Letter_S[9].B; PORTC =Letter_S[9].C;  break;

		  case 109: PORTA = 0x08;	break;
		  case 110: PORTA = 0x08;   break;		  
		  case 111: PORTA = 0x08;	break;		  
		  case 112: PORTA = 0x08;   break;		  
		  case 113: PORTA = 0x08;   break;		  
	  

		  case 116:  PORTA =Letter_Y[0].A;PORTB =Letter_Y[0].B; PORTC =Letter_Y[0].C;  break;
		  case 117:  PORTA =Letter_Y[1].A;PORTB =Letter_Y[1].B; PORTC =Letter_Y[1].C;  break;
		  case 118:  PORTA =Letter_Y[2].A;PORTB =Letter_Y[2].B; PORTC =Letter_Y[2].C;  break;
		  case 119:  PORTA =Letter_Y[3].A;PORTB =Letter_Y[3].B; PORTC =Letter_Y[3].C;  break;
		  case 120:  PORTA =Letter_Y[4].A;PORTB =Letter_Y[4].B; PORTC =Letter_Y[4].C;  break;
		  case 121:  PORTA =Letter_Y[5].A;PORTB =Letter_Y[5].B; PORTC =Letter_Y[5].C;  break;
		  case 122:  PORTA =Letter_Y[6].A;PORTB =Letter_Y[6].B; PORTC =Letter_Y[6].C;  break;
		  case 123:  PORTA =Letter_Y[7].A;PORTB =Letter_Y[7].B; PORTC =Letter_Y[7].C;  break;
		  case 124:  PORTA =Letter_Y[8].A;PORTB =Letter_Y[8].B; PORTC =Letter_Y[8].C;  break;
		  case 125:  PORTA =Letter_Y[9].A;PORTB =Letter_Y[9].B; PORTC =Letter_Y[9].C;  break;


		   case 127:PORTA=	Letter_C[0].A; PORTB=  Letter_C[0].B; PORTC =Letter_C[0].C; break;
           case 128:PORTA=	Letter_C[1].A; PORTB=  Letter_C[1].B; PORTC =Letter_C[1].C; break;
           case 129:PORTA=	Letter_C[2].A; PORTB=  Letter_C[2].B; PORTC =Letter_C[2].C; break;
           case 130:PORTA=	Letter_C[3].A; PORTB=  Letter_C[3].B; PORTC =Letter_C[3].C; break;
        	 case 131:PORTA=	Letter_C[4].A; PORTB=  Letter_C[4].B; PORTC =Letter_C[4].C; break;
        	 case 132:PORTA=	Letter_C[5].A; PORTB=  Letter_C[5].B; PORTC =Letter_C[5].C; break;
        	 case 133:PORTA=	Letter_C[6].A; PORTB=  Letter_C[6].B; PORTC =Letter_C[6].C; break;
        	 case 134:PORTA=	Letter_C[7].A; PORTB=  Letter_C[7].B; PORTC =Letter_C[7].C; break;
	







  		   default: PORTA = 0;
					PORTB = 0;
					PORTC = 0; break;      
          }
          break;
        }
		default:{

			break;
		}
	}
     
	}
	TCNT3 = 0;

}

void pass_value(struct Letter_row* src, struct Letter_row* dest,int size)
{
	int i;
	for(i=0;i<size;i++)
	{
		dest[i]=src[i];
		}
}	

int main(void)
{ 
  int num;
   for(num=0;num<13;num++)
	{
 		Letter1[num]=Letter_A[num];
	}
	
	for(num=0;num<13;num++)
	{
 		Letter2[num]=Letter_B[num];
	}
	
	for(num=0;num<8;num++)
	{
 		Number_0[num]=Num_0[num];
	}
	

  DDRD|= 0x80;
	DDRA = 0xFF;
	DDRB = 0xFF;
	DDRC = 0xFF;
	
	EIMSK = 1<<INT0 ; // turn on int0
	EIMSK |= 1<<INT1;
  	EICRA = 0xB;       // falling edge

	// turn on timer 2 to be read in int0 ISR
   TCCR3B = 3; // divide by 1024
  // turn on timer 2 overflow ISR for double precision time
   //TIMSK3= (1<<OCIE3A); //overflow 
   TIMSK3 = 2;
   //TCCR3A= (1<<WGM31) ; //clear on match
  	//OCR3A = 50;

   TIMSK0 = 2;
   TCCR0B =  3;
   OCR0A = 249;
   
   TIMSK2 = 2;
   TCCR2B = 3;
   OCR2A = 79;

   
   
  //set up timer 0 for 1 mSec timebase 
  //TIMSK0= (1<<OCIE0A);	//turn on timer 0 cmp match ISR 
  //OCR0A = 249;  		//set the compare reg to 250 time ticks
  //set prescalar to divide by 64 
  TCCR1B= 3; 	

   sei();

   while(1){
   	if(display_on)
   	PORTD |=0x80;
  
  switch (second%10){
			
	case 0: pass_value(Num_0,Number_5,8); break;
	case 1: pass_value(Num_1,Number_5,8); break;
	case 2: pass_value(Num_2,Number_5,8); break;
	case 3: pass_value(Num_3,Number_5,8); break;
	case 4: pass_value(Num_4,Number_5,8); break;
	case 5: pass_value(Num_5,Number_5,8); break;
	case 6: pass_value(Num_6,Number_5,8); break;
	case 7: pass_value(Num_7,Number_5,8); break;
	case 8: pass_value(Num_8,Number_5,8); break;
	case 9: pass_value(Num_9,Number_5,8); break;
  default: break;}
  	
  	
    switch (second/10){
			
	case 0: pass_value(Num_0,Number_4,8); break;
	case 1: pass_value(Num_1,Number_4,8); break;
	case 2: pass_value(Num_2,Number_4,8); break;
	case 3: pass_value(Num_3,Number_4,8); break;
	case 4: pass_value(Num_4,Number_4,8); break;
	case 5: pass_value(Num_5,Number_4,8); break;

  default: break;	
										
	}
	
	
	  switch (minute %10){
			
	case 0: pass_value(Num_0,Number_3,8); break;
	case 1: pass_value(Num_1,Number_3,8); break;
	case 2: pass_value(Num_2,Number_3,8); break;
	case 3: pass_value(Num_3,Number_3,8); break;
	case 4: pass_value(Num_4,Number_3,8); break;
	case 5: pass_value(Num_5,Number_3,8); break;
	case 6: pass_value(Num_6,Number_3,8); break;
	case 7: pass_value(Num_7,Number_3,8); break;
	case 8: pass_value(Num_8,Number_3,8); break;
	case 9: pass_value(Num_9,Number_3,8); break;
  default: break;}
  
  switch (minute/10){
			
	case 0: pass_value(Num_0,Number_2,8); break;
	case 1: pass_value(Num_1,Number_2,8); break;
	case 2: pass_value(Num_2,Number_2,8); break;
	case 3: pass_value(Num_3,Number_2,8); break;
	case 4: pass_value(Num_4,Number_2,8); break;
	case 5: pass_value(Num_5,Number_2,8); break;

  default: break;	}
  
  	  switch (hour %10){
			
	case 0: pass_value(Num_0,Number_1,8); break;
	case 1: pass_value(Num_1,Number_1,8); break;
	case 2: pass_value(Num_2,Number_1,8); break;
	case 3: pass_value(Num_3,Number_1,8); break;
	case 4: pass_value(Num_4,Number_1,8); break;
	case 5: pass_value(Num_5,Number_1,8); break;
	case 6: pass_value(Num_6,Number_1,8); break;
	case 7: pass_value(Num_7,Number_1,8); break;
	case 8: pass_value(Num_8,Number_1,8); break;
	case 9: pass_value(Num_9,Number_1,8); break;
  default: break;}
  
   switch (hour/10){
			
	case 0: pass_value(Num_0,Number_0,8); break;
	case 1: pass_value(Num_1,Number_0,8); break;


  default: break;	}
  
  
		// if (new_code  == 1){
			// new_code = 0;
			// PORTB = 0xFF;
			// switch (key_code){
				// case 0xf0: break;
			// }			
		// }
	}
}
