
int new_code;
int display_on;

static struct IR_data    
{
    unsigned char addr1;     
    unsigned char addr2;     
    unsigned char data1;    
    unsigned char data2;    
} IR_DATA;
#define GTime 53                
#define CTime 114               
#define D0MinTime 4  
#define D0MaxTime 9  
#define D1MinTime 11  
#define D1MaxTime 16             
#define TimeOut_cnt 250 

 int minute = 10;
 int second = 40;
 int hour = 15;

 int lock=0;
 int sft_en=0;
 int cursor_num=0;
		 int cursor_on=0;
		 int cursor=0;
int cursor_pos[6]={0,8,22,30,43,52};

 unsigned char T0_CNT;       
 unsigned char T0_CNT_bk;        
 char TimeOut;                
 char Guide;                        
 char Continuous;                   
 unsigned char IR_Time[33]; 
unsigned char key_code;

ISR(TIMER2_COMPA_vect)
{
    T0_CNT ++;
	
    if(T0_CNT > TimeOut_cnt)
    {
        TimeOut = 1;   
    }
	TCNT2   = 0;
}


void changetime(unsigned char Data, int num)
{
switch(num)
{
case 0: 
        {
		switch (Data)
		{
		case 0x16: hour = hour%10;    break;	
		case 0x0c: hour = hour%10+10; break;
		case 0x18:{if(hour<14) hour = hour%10+20; break;}	
		default: break;
		}
		}break;
case 1: 
        {
		switch (Data)
		{
		case 0x16: hour = (hour/10)*10+0; break;
		case 0x0c: hour = (hour/10)*10+1; break;
		case 0x18: hour = (hour/10)*10+2; break;
		case 0x5e: hour = (hour/10)*10+3; break;
		case 0x08: {if(hour<20)hour = (hour/10)*10+4; break;}
		case 0x1c: {if(hour<20)hour = (hour/10)*10+5; break;}
		case 0x5a: {if(hour<20)hour = (hour/10)*10+6; break;}
		case 0x42: {if(hour<20)hour = (hour/10)*10+7; break;}
		case 0x52: {if(hour<20)hour = (hour/10)*10+8; break;}
		case 0x4a: {if(hour<20)hour = (hour/10)*10+9; break;}
		default: break;}
		}break;
case 2: 
        {
		switch (Data){
		case 0x16: minute = minute%10+0; break;
		case 0x0c: minute = minute%10+10; break;
		case 0x18: minute = minute%10+20; break; 
		case 0x5e: minute = minute%10+30; break;
		case 0x08: minute = minute%10+40; break;
		case 0x1c: minute = minute%10+50; break;
		default: break;}
		}break;

case 3: {
		switch (Data){
		case 0x16: minute = (minute/10)*10+0; break;
		case 0x0c: minute = (minute/10)*10+1; break;
		case 0x18: minute = (minute/10)*10+2; break;
		case 0x5e: minute = (minute/10)*10+3; break;
		case 0x08: minute = (minute/10)*10+4; break;
		case 0x1c: minute = (minute/10)*10+5; break;
		case 0x5a: minute = (minute/10)*10+6; break;
		case 0x42: minute = (minute/10)*10+7; break;
		case 0x52: minute = (minute/10)*10+8; break;
		case 0x4a: minute = (minute/10)*10+9; break;
		default: break;}
		}break;

case 4:  {
		switch (Data){
		case 0x16: second = second%10+0; break;
		case 0x0c: second = second%10+10; break;
		case 0x18: second = second%10+20; break; 
		case 0x5e: second = second%10+30; break;
		case 0x08: second = second%10+40; break;
		case 0x1c: second = second%10+50; break;
		default: break;}
		}break;

case 5: {
		switch (Data){
		case 0x16: second = (second/10)*10+0; break;
		case 0x0c: second = (second/10)*10+1; break;
		case 0x18: second = (second/10)*10+2; break;
		case 0x5e: second = (second/10)*10+3; break;
		case 0x08: second = (second/10)*10+4; break;
		case 0x1c: second = (second/10)*10+5; break;
		case 0x5a: second = (second/10)*10+6; break;
		case 0x42: second = (second/10)*10+7; break;
		case 0x52: second = (second/10)*10+8; break;
		case 0x4a: second = (second/10)*10+9; break;
		default: break;}
		}break;
	}
}

 


void Decode(void)
{
    unsigned char i=0x00,j,k;
    static unsigned char *p; 
    EIMSK &=  ~ (1<<INT1);

    p = &IR_DATA.addr1;
    for(k=0; k<4; k++)
    {
        for(j=0; j<8; j++)
        {
            if((IR_Time[i]>D0MinTime) & (IR_Time[i]<D0MaxTime))
            {
                *p >>= 1;         
                *p &= 0x7f;         
            }
            else if((IR_Time[i]>D1MinTime) & (IR_Time[i]<D1MaxTime))
            {
                *p >>= 1;              
                *p |= 0x80;            
            }
            i ++;
        }
        p ++;
    }
    
    if(IR_DATA.data2+IR_DATA.data1==0XFF)
    {
    if(((IR_DATA.data1!=0x52) && (IR_DATA.data1!=0x4a)&&(!lock)&&(IR_DATA.data1!=0x07)&&(IR_DATA.data1!=0x09))||(IR_DATA.data1==0x44))
    	{
    key_code=IR_DATA.data1;
		}
		else{}
		if((IR_DATA.data1==0x52) &&(!sft_en))
			sft_en = 1;
	    else{}
	  if((IR_DATA.data1==0x4a) &&(sft_en))
		    sft_en = 0;
        else{}
        	
    if(( lock)&&(key_code==0x44))
    	changetime(IR_DATA.data1,cursor_num);
    else
    	{}
    
    if(((IR_DATA.data1!=0x44)&&(!lock)&&(IR_DATA.data1!=0x52) && (IR_DATA.data1!=0x4a)&&(IR_DATA.data1!=0x07)&&(IR_DATA.data1!=0x09))||(IR_DATA.data1==0x44))
	  new_code=1;
	  else{}
	  if(IR_DATA.data1==0x44)
	  lock=~lock;
	  else{}
    // if(key_code == 0x44 ) PORTA = key_code;
		//if (key_code == 0x45) PORTC = 0x10; //power
		//if(key_code == 0x0C) PORTC = 0x80;  //1
		//if (key_code == 0x07) PORTC = 0x80; //<<
		//if (key_code == 0x47) PORTC = 0x80; //<<
		//0x47 menu

        //PORTA = IR_DATA.data1;


	    if ((IR_DATA.data1 == 0x07)&&(cursor_num>0))
		{
		cursor_num--;
		cursor = cursor_pos[cursor_num];
		}
		else
		{}
        if ((IR_DATA.data1 == 0x09)&&(cursor_num<5))
		{
		cursor_num++;
		cursor = cursor_pos[cursor_num];
		} 
		else{}		

		
			
		if (key_code == 0x45 && display_on == 0) {display_on = 1;}
		else if( key_code == 0x45 && display_on == 1)  {display_on = 0;}
		else {}
		
    }
    else
    {
        key_code=0XFF;   
    };
   
    EIMSK |= 1<<INT1;   
} 
ISR(INT1_vect) 
{
    static unsigned char m=0;
	TCNT2 = 0;
	TCCR2B= 3;
	
    T0_CNT_bk = T0_CNT;    
    T0_CNT = 0x00;      
    if(TimeOut)        
    {
 
        TimeOut = 0;       
        m = 0;              
        T0_CNT = 0x00;     
        Guide = 0;       
        Continuous = 0;    
    }
    else       
    {
        if(Guide | Continuous)        
        {
            IR_Time[m++] = T0_CNT_bk;     
            if(m == 32)  
            {
                m = 0;
                Guide = 0;   
				 //new_code=1;
				TCNT2 = 0;
				TCCR2B=0;
               
                Decode();    
					
            }
        }
        if(T0_CNT_bk > GTime)  
        {
            Guide = 1;        
            m = 0;
        };
        if(T0_CNT_bk > CTime)    
        {
            Continuous = 1;   
            m = 0;
        }
    }
}
